import {
    createSelector,
    createFeatureSelector,
    ActionReducerMap,
  } from '@ngrx/store';

  import { StateSelector } from 'packages/core/ngrx/store';

  import { MODULE } from '../notification.constant';

  import * as NotificationStore from './notification';

  export interface State {
    notifications: NotificationStore.State;
  }

  export const REDUCERS = {
    notifications: NotificationStore.reducer,
  };

  export const EFFECTS = [
    NotificationStore.Effects,
  ];

  export const selectNotificationState = createFeatureSelector<State>(MODULE.name);

  export const ReadAllByMemberSelector = new StateSelector<NotificationStore.State>(createSelector(
    selectNotificationState,
    (state: State) => state.notifications
  ));
