import { Action } from '@ngrx/store';

import { RPCError } from 'packages/core/rpc/error';

import { Notification } from '../../model';
import { Member } from '../../../member/model';
import { PageParams } from 'app/commons/model';

export enum ActionType {
  ReadAllByMember = '[Notification.notification] ReadAllByMember',
  ReadAllByMemberSuccess = '[Notification.notification] ReadAllByMemberSuccess',
  ReadAllByMemberFailure = '[Notification.notification] ReadAllByMemberFailure',
}

export class ReadAllByMember implements Action {
  readonly type = ActionType.ReadAllByMember;

  constructor(public payload: { member: Member, pageParams: PageParams }) {}
}

export class ReadAllByMemberSuccess implements Action {
  readonly type = ActionType.ReadAllByMemberSuccess;

  constructor(public payload: Notification[]) {}
}

export class ReadAllByMemberFailure implements Action {
  readonly type = ActionType.ReadAllByMemberFailure;

  constructor(public payload: RPCError) {}
}

export type Actions =
  | ReadAllByMember
  | ReadAllByMemberSuccess
  | ReadAllByMemberFailure
;
